package libdbase;

sub main'parseargv {
    local($flags) = shift;
    local($outfile) = shift;

    # if STDOUT is not a tty (pipe to lpr, etc.), output to STDOUT
    # otherwise, output to our default file passed to the procedure
    if (! -t STDOUT) { $outfile = "-"; }

    while ($_ = shift) {
	if (/^-o.*/) {
	    $outfile = shift;
	} elsif (/^[bpalfoew]+-?$/) {
	    $flags = $_;
	} else {
	    print <<EOF;
Usage: $0 [flags] [-o file]
       flags are one or more of [bpalfoew]
	b -- brothers
	p -- pledges
	a -- advisors
        l -- alumni
	o -- other (Sectional, Regional, and National staff)
	f -- friends (friends of the chapter and/or prospectives)
	e -- everyone (excludes others and friends), or
	w -- world (includes others and friends)
    append "-" to the flag if you want to print out the people that are
    normally hidden also (see example 3.)
EOF
	    die "unknown argument: $_";
	}
    }
    $_ = $flags;

    # "everybody" is brothers, pledges, advisors, and alumni    s/e/bpal/;
    s/e/bpal/;

    s/w/bpalof/;		# "world" is lots of people

    tr/a-z/A-Z/;		# capitalize flags
    ($_, $outfile);		# return
}    

sub main'statflags {
    local($flags) = @_;
    local(%regex);
    if (index($flags, "-") > 0) {
	$visible = '.';		# print "invisible" people
    } else {
	$visible = '\+';	# don't print
    }
    if (index($flags, "B") >= 0) { $regex{"brother"} = "B" . $visible; }
    if (index($flags, "P") >= 0) { $regex{"pledge"}  = "P" . $visible; }
    if (index($flags, "A") >= 0) { $regex{"advisor"} = "A" . $visible; }
    if (index($flags, "L") >= 0) { $regex{"alumnus"} = "L" . $visible; }
    if (index($flags, "F") >= 0) { $regex{"friend"}  = "F" . $visible; }
    if (index($flags, "O") >= 0) { $regex{"other"}   = "O" . $visible; }
    %regex;
}

sub main'progname {
    $_ = $0;
    s,^.*/,,;
    s/\.perl$//;
    $_;
}
   
1;
